#include <iostream>
#include <string>
using namespace std;

class dama {
   private:
   int x;
   int y;
   public:
   dama(int xx = 1, int yy = 1): x(xx), y(yy){}
   void posun(int xx, int yy) {
      x = xx;
      y = yy;
   }
   int getX() const {
      return x;
   }
   int getY() const {
      return y;
   }
   bool operator==(const dama& rhs) const {
      return ((rhs.getX() == x) && (rhs.getY() == y));
   }
   bool v_ohrozeni(const dama& rhs) const {
      if ((x == rhs.getX()) || (y == rhs.getY())) {
         return true;
      }
      dama d1, d2;
      if (rhs.getX() < x) {
         d1 = rhs;
         d2 = *this;
      } else {
         d1 = *this;
         d2 = rhs;
      }
      if (d2.getY() == (d1.getY() + d2.getX() - d1.getX())) {
         return true;
      }
      if (d2.getY() == (d1.getY() - d2.getX() + d1.getX())) {
         return true;
      }
      return false;
   }      
};

const char preklad[9] = {' ', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H'};

void zobraz(dama (&sachovnice)[8]) {
   cout << "\n";
   for (int radek = 8; radek > 0; radek--) {
      cout << radek << "  |";
      for (int sloupec = 1; sloupec < 9; sloupec++) {
         if (sachovnice[sloupec-1].getY() == radek) {
            cout << "D|";
         } else {
            cout << " |";
         }
      }
      cout << endl;
   }
   cout << "\n    ";
   for (int i = 1; i < 9; i++) {
      cout << preklad[i] << " ";
   }
   cout << endl << endl;
}
      
int pocet_ohrozeni(dama (&sachovnice)[8], int x, int y) {
   int cnt = 0;
   dama d(x,y);
   for (int i = 0; i < (x-1); i++) {
      if (d.v_ohrozeni(sachovnice[i])) {
         cnt++;
      }
   }
   for (int i = x; i < 8; i++) {
      if (d.v_ohrozeni(sachovnice[i])) {
         cnt++;
      }
   }
   return cnt;
}
      
      
int main() {
   dama sachovnice[8];
   string radek;
   for (int i = 8; i > 0; i--) {
      getline(cin,radek);
      if (radek.length() < 17) {
         cerr << "Radek " << i << " ma malo znaku\nInkriminovany radek: '";
         cerr << radek << "'\n";
         return 2;
      }
      for (int j = 0; j < 8; j++) {
         if (radek[j*2 + 1] == 'D') {
            sachovnice[j].posun(j+1,i);
         }
      }
   }
   cout << "Rozmisteni dam:\n";
   zobraz(sachovnice);
   int pn = 0;
   for (int i = 0; i < 8; i++) {
      pn += pocet_ohrozeni(sachovnice, sachovnice[i].getX(), sachovnice[i].getY());
   }
   cout << "Pocet pocatecnich ohrozeni: " << pn/2 << endl;
   int napadanych_dam = 8;
   int aktualni_dama = 0;
   int pocet_uprav = 0;
   while (napadanych_dam > 0) {
      napadanych_dam = 0;
      for (int i = 0; i < 8; i++) {
         aktualni_dama = (aktualni_dama + 1) % 8;
         int aktualni_ohrozeni;
         if ((aktualni_ohrozeni = pocet_ohrozeni(sachovnice,
                                                 sachovnice[aktualni_dama].getX(),
                                                 sachovnice[aktualni_dama].getY()
                                                )) > 0) {
            //cout << "Dama " << (aktualni_dama + 1) << " je v napadana " << aktualni_ohrozeni << "x\n";
            napadanych_dam++;
            int minimalni_ohrozeni = 8;
            int min_index = 1;
            for (int i = 0; i < 8; i++) {
               int po = pocet_ohrozeni(sachovnice, aktualni_dama+1, i+1);
               if ((po < minimalni_ohrozeni) && ((i+1) != sachovnice[aktualni_dama].getY())) {
                  minimalni_ohrozeni = po;
                  min_index = i+1;
               } 
               if (minimalni_ohrozeni == 0) {
                  break;
               }
            }
            sachovnice[aktualni_dama].posun(aktualni_dama+1, min_index);
            pocet_uprav++;
         }
      }
   }
   zobraz(sachovnice);
   cout << "Pocet presunu: " << pocet_uprav << endl;      
   return 0;
}
